//
//  Cocoa_jwSMTP.h
//  Cocoa_jwSMTP
//
//  Created by Jim Turner on 10/24/07.
//  Copyright 2007 Startly Technologies, LLC. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@interface Cocoa_jwSMTP : NSObject 
{
	NSArray  *_recipients;
	NSString *_fromAddress;
	NSString *_subject;
	NSString *_messageBody;
	NSString *_smtpServer;
	unsigned short _smtpPort;
	BOOL _mxLookup;
	NSString *_attachment;
	
	NSString *_result;
	BOOL _currentlySending;
}

// For sending to a single recipient (or a comma-delimited list of them)
-(void) sendEmailTo:(NSString *)to from:(NSString *)from subject:(NSString *)subject messageBody:(NSString *)messageBody smtpServer:(NSString *)smtpServer;

// Send to a list of users defined by addresses 
-(void) sendEmailToAddresses:(NSArray *)addresses from:(NSString *)from subject:(NSString *)subject messageBody:(NSString *)messageBody smtpServer:(NSString *)smtpServer;

// Start the mail sending process
-(void) sendMessage;

#pragma mark KVO accessors
// jwsmtp::mailer::send blocks until it's finished.  This allows us to report when we're
// in the process of sending and when we finish.
-(BOOL) currentlySending;
-(void) setCurrentlySending:(NSNumber *)currentlySending;

// Returns the status of the message send.
-(NSString *)result;
-(void) setResult:(NSString *)result;

#pragma mark Accessors
-(NSArray *) recipients;
-(void) setRecipients:(NSArray *) recipients;
-(void) addRecipient:(NSString *) address;
-(void) removeRecipient:(NSString *) address;

// This method can accept a comma-delimited list of addresses
-(void) setToAddress:(NSString *) toAddress;

-(NSString *) fromAddress;
-(void) setFromAddress:(NSString *) fromAddress;

-(NSString *) subject;
-(void) setSubject:(NSString *) subject;

-(NSString *) messageBody;
-(void) setMessageBody:(NSString *) messageBody;

-(NSString *)smtpServer;
-(void) setSmtpServer:(NSString *) smtpServer;

-(unsigned short) smtpPort;
-(void) setSmtpPort:(unsigned short) smtpPort;

-(BOOL) mxLookup;
-(void) setMxLookup:(BOOL) mxLookup;

-(NSString *) attachment;
-(void) setAttachment:(NSString *) attachment;

@end
